/***************************************************************************************
  *
  * InstallDriver.h - Include File for "InstallDriver.cpp" Source File.
  *
  * Copyright(c) 2003, Vito Plantamura. All rights reserved.
  *
***************************************************************************************/

//
// ### Required Header Files. ###
//

#include <windows.h>

//
// ### Event Notification Function. ###
//

typedef void ( _cdecl * INSTALLDRV_LOGEVENT ) ( DWORD dwEventMsgId, WORD wEventType, LPCTSTR pFormat, ... );
	// ### INSTALLDRV_LOGEVENT Note: --> Use a NULL to terminate the parameters list. ###

//
// ### Event Message IDs for InstallDriver Module. ###
//

#define INSTALLDRV_MSG_WASNOTFOUND			0
#define INSTALLDRV_MSG_ERRORLOADING			1
#define INSTALLDRV_MSG_WRONGVERSION			2

//
// ### Event Message String Formats for InstallDriver Module (English). ###
//

#define INSTALLDRV_MSGFMTENG_WASNOTFOUND			""%1" was not found."
#define INSTALLDRV_MSGFMTENG_ERRORLOADING			"Error loading %1 ("%2"): %3."
#define INSTALLDRV_MSGFMTENG_WRONGVERSION			"The version of the Kernel Driver is not correct. Please reboot and try again."

//
// ### Function Prototypes. ###
//

BOOL StartVersionedDeviceDriver( HANDLE * lphDevice, LPCTSTR pszSysFile, LPCTSTR pszSysName, DWORD dwGetVerIoctl, DWORD dwExpectedVerNum, INSTALLDRV_LOGEVENT pfnLogEvent );
	// ### StartVersionedDeviceDriver Note: -->
	//       "pszSysFile" is something in the form of "DriverName.Sys".
	//       "pszSysName" is something in the form of "DriverName".
	//       "dwGetVerIoctl" is the IO Control Code for getting the Driver Version.
	//       "dwExpectedVerNum" is the Version Number that the caller is expecting from the loader driver. ###

BOOL CreateDriverFileFromAppResources( HINSTANCE hResMod, LPCTSTR pszName, LPCTSTR pszType, LPCTSTR pszSysFile );
	// ### CreateDriverFileFromAppResources Note: -->
	//		"hResMod" is something returned by a function such as ::AfxGetResourceHandle().
	//		"pszSysFile" is something in the form of "DriverName.Sys". ###

BOOL DeleteDriverFile( LPCTSTR pszSysFile );
	// ### DeleteDriverFile Note: -->
	//		"pszSysFile" is something in the form of "DriverName.Sys". ###

BOOL UnloadDeviceDriver( const TCHAR * Name );
	// ### UnloadDeviceDriver Note: -->
	//       "Name" is something in the form of "DriverName".
